Index: palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- palm/trunk/SOURCE/data_output_module.f90	(revision 4596)
+++ palm/trunk/SOURCE/data_output_module.f90	(revision 4597)
@@ -3268,6 +3370,6 @@
 
     INTEGER, INTENT(IN) ::  file_id              !< file ID
+    INTEGER             ::  return_value         !< return value
     INTEGER             ::  output_return_value  !< return value of a called output routine
-    INTEGER             ::  return_value         !< return value
     INTEGER, INTENT(IN) ::  variable_id          !< variable ID
 
@@ -3335,32 +3437,32 @@
 
              CASE( 'char' )
-                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,            &
-                        attribute_name=attribute%name, value_char=attribute%value_char,            &
-                        return_value=output_return_value )
+                CALL netcdf4_write_attribute( mode=file_format(9:), file_id=file_id,               &
+                        variable_id=variable_id, attribute_name=attribute%name,                    &
+                        value_char=attribute%value_char, return_value=output_return_value )
 
              CASE( 'int8' )
-                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,            &
-                        attribute_name=attribute%name, value_int8=attribute%value_int8,            &
-                        return_value=output_return_value )
+                CALL netcdf4_write_attribute( mode=file_format(9:), file_id=file_id,               &
+                        variable_id=variable_id, attribute_name=attribute%name,                    &
+                        value_int8=attribute%value_int8, return_value=output_return_value )
 
              CASE( 'int16' )
-                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,            &
-                        attribute_name=attribute%name, value_int16=attribute%value_int16,          &
-                        return_value=output_return_value )
+                CALL netcdf4_write_attribute( mode=file_format(9:), file_id=file_id,               &
+                        variable_id=variable_id, attribute_name=attribute%name,                    &
+                        value_int16=attribute%value_int16, return_value=output_return_value )
 
              CASE( 'int32' )
-                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,            &
-                        attribute_name=attribute%name, value_int32=attribute%value_int32,          &
-                        return_value=output_return_value )
+                CALL netcdf4_write_attribute( mode=file_format(9:), file_id=file_id,               &
+                        variable_id=variable_id, attribute_name=attribute%name,                    &
+                        value_int32=attribute%value_int32, return_value=output_return_value )
 
              CASE( 'real32' )
-                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,            &
-                        attribute_name=attribute%name, value_real32=attribute%value_real32,        &
-                        return_value=output_return_value )
+                CALL netcdf4_write_attribute( mode=file_format(9:), file_id=file_id,               &
+                        variable_id=variable_id, attribute_name=attribute%name,                    &
+                        value_real32=attribute%value_real32, return_value=output_return_value )
 
              CASE( 'real64' )
-                CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,            &
-                        attribute_name=attribute%name, value_real64=attribute%value_real64,        &
-                        return_value=output_return_value )
+                CALL netcdf4_write_attribute( mode=file_format(9:), file_id=file_id,               &
+                        variable_id=variable_id, attribute_name=attribute%name,                    &
+                        value_real64=attribute%value_real64, return_value=output_return_value )
 
              CASE DEFAULT
@@ -3408,5 +3510,5 @@
     INTEGER, INTENT(OUT) ::  return_value  !< return value
 
-    LOGICAL ::  found = .FALSE.  !< true if dimension required by variable was found in dimension list
+    LOGICAL ::  found  !< true if dimension required by variable was found in dimension list
 
     TYPE(dimension_type), DIMENSION(:), INTENT(IN) ::  dimensions  !< list of dimensions in file
@@ -3415,5 +3517,6 @@
 
 
-    return_value  = 0
+    return_value = 0
+    found = .FALSE.
     ndims = SIZE( dimensions )
     nvars = SIZE( variables )
@@ -3473,5 +3576,5 @@
 
        CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
-          CALL netcdf4_stop_file_header_definition( file_id, output_return_value )
+          CALL netcdf4_stop_file_header_definition( file_format(9:), file_id, output_return_value )
 
        CASE DEFAULT
@@ -3500,5 +3603,5 @@
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE find_var_in_file( file_name, variable_name, file_format, file_id, variable_id,         &
-                              is_global, dimensions, return_value )
+                              write_only_by_master_rank, dimensions, return_value )
 
     CHARACTER(LEN=*), PARAMETER ::  routine_name = 'find_var_in_file'  !< name of routine
@@ -3517,6 +3620,6 @@
     INTEGER, DIMENSION(:), ALLOCATABLE ::  dimension_ids  !< list of dimension IDs used by variable
 
-    LOGICAL              ::  found      !< true if requested variable found in requested file
-    LOGICAL, INTENT(OUT) ::  is_global  !< true if variable is global
+    LOGICAL              ::  found                      !< true if requested variable found in requested file
+    LOGICAL, INTENT(OUT) ::  write_only_by_master_rank  !< true if only master rank shall write variable
 
     TYPE(dimension_type), DIMENSION(:), ALLOCATABLE, INTENT(OUT) ::  dimensions  !< list of dimensions used by variable
@@ -3546,6 +3649,6 @@
              IF ( TRIM( variable_name ) == TRIM( files(f)%variables(d)%name ) )  THEN
 
-                variable_id    = files(f)%variables(d)%id
-                is_global = files(f)%variables(d)%is_global
+                variable_id = files(f)%variables(d)%id
+                write_only_by_master_rank = files(f)%variables(d)%write_only_by_master_rank
 
                 ALLOCATE( dimension_ids(SIZE( files(f)%variables(d)%dimension_ids )) )
@@ -3578,6 +3681,6 @@
                 IF ( TRIM( variable_name ) == TRIM( files(f)%dimensions(d)%name ) )  THEN
 
-                   variable_id    = files(f)%dimensions(d)%variable_id
-                   is_global = .TRUE.
+                   variable_id = files(f)%dimensions(d)%variable_id
+                   write_only_by_master_rank = files(f)%dimensions(d)%write_only_by_master_rank
 
                    ALLOCATE( dimensions(1) )
@@ -3741,5 +3844,5 @@
 
     INTEGER, PARAMETER ::  indent_depth = 3        !< space per indentation
-    INTEGER, PARAMETER ::  max_keyname_length = 6  !< length of longest key name
+    INTEGER, PARAMETER ::  max_keyname_length = 8  !< length of longest key name
 
     CHARACTER(LEN=50) ::  write_format1  !< format for write statements
@@ -3805,5 +3908,5 @@
     SUBROUTINE print_attributes( indent_level, attributes )
 
-       INTEGER, PARAMETER  ::  max_keyname_length = 6  !< length of longest key name
+       INTEGER, PARAMETER ::  max_keyname_length = 6  !< length of longest key name
 
        CHARACTER(LEN=50) ::  write_format1  !< format for write statements
@@ -3865,5 +3968,5 @@
     SUBROUTINE print_dimensions( indent_level, dimensions )
 
-       INTEGER, PARAMETER  ::  max_keyname_length = 15  !< length of longest key name
+       INTEGER, PARAMETER ::  max_keyname_length = 26  !< length of longest key name
 
        CHARACTER(LEN=50) ::  write_format1  !< format for write statements
@@ -3900,4 +4003,6 @@
           WRITE( debug_output_unit, TRIM( write_format2 ) // ',I7)' )                              &
              'id', dimensions(i)%id
+          WRITE( debug_output_unit, TRIM( write_format2 ) // ',L1)' )                              &
+             'write only by master rank', dimensions(i)%write_only_by_master_rank
           WRITE( debug_output_unit, TRIM( write_format2 ) // ',I7)' )                              &
              'length', dimensions(i)%length
@@ -4080,5 +4185,5 @@
     SUBROUTINE print_variables( indent_level, variables )
 
-       INTEGER, PARAMETER  ::  max_keyname_length = 16  !< length of longest key name
+       INTEGER, PARAMETER ::  max_keyname_length = 26  !< length of longest key name
 
        CHARACTER(LEN=50) ::  write_format1  !< format for write statements
@@ -4111,5 +4216,5 @@
              'id', variables(i)%id
           WRITE( debug_output_unit, TRIM( write_format2 ) // ',L1)' )                              &
-             'is global', variables(i)%is_global
+             'write only by master rank', variables(i)%write_only_by_master_rank
 
           WRITE( debug_output_unit, TRIM( write_format2 ) // ',A)', ADVANCE='no' )                 &
